//+------------------------------------------------------------------+
//|                                                CCI_Highlight.mq4 |
//|                             Copyright (c) 2016, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//|                                   Paypal: https://goo.gl/9Rj74e  | 
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |                    
//|                                          mario.jemic@gmail.com   |
//|                   BitCoin : 15VCJTLaz12Amr7adHSBtL9v8XomURo9RF   |
//+------------------------------------------------------------------+

#property indicator_buffers 11
#property indicator_separate_window
#property indicator_width1  3
#property indicator_color1  clrGreen
#property indicator_width2  3
#property indicator_color2  clrMaroon
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  2
#property indicator_color5  clrLime
#property indicator_width6  2
#property indicator_color6  clrRed
#property indicator_width7  2
#property indicator_color7  clrRed
#property indicator_color8  clrYellow
#property indicator_width8  2
#property indicator_color9  clrDarkGray
#property indicator_style9  STYLE_DOT
#property indicator_color10 clrDarkGray
#property indicator_style10 STYLE_DOT
#property indicator_color11 clrDarkGray
#property indicator_style11 STYLE_DOT


extern int            CCI_Period1    = 50;
extern int            CCI_Period2    = 14;
extern int            CCI_OverBought = 100;
extern int            CCI_OverSold   = -100;
input bool            alertsOn        = false;          // Alerts on true/false?
input bool            alertsOnCurrent = true;           // Alerts on open bar true/false?
input bool            alertsMessage   = true;           // Alerts message true/false?
input bool            alertsSound     = false;          // Alerts sound true/false?
input bool            alertsNotify    = false;             // Alerts push notification true/false?
input bool            alertsEmail     = false;          // Alerts email true/false?
input string          soundFile       = "alert2.wav";   // Sound file
input bool            arrowsVisible         = true;             // Arrows visible?
//input bool                arrowsOnFirst         = false;            // Arrows shift?
input string              arrowsId              = "CCIa";        // Unique ID for arrows
input double              arrowsUpperGap        = 1.0;              // Upper arrow gap
input double              arrowsLowerGap        = 1.0;              // Lower arrow gap
input color               arrowsUpColor         = clrBlue;          // Up arrow color
input color               arrowsDnColor         = clrCrimson;       // Down arrow color
input int                 arrowsUpCode          = 221;              // Up arrow code
input int                 arrowsDnCode          = 222;              // Down arrow code
input int                 arrowsUpSize          = 2;                // Up arrow size
input int                 arrowsDnSize          = 2;                // Down arrow size

double CCI1[],vala[],valb[],CCI_HistoUp[],CCI_HistoDn[],CCI_HistoUp_BG[],CCI_HistoDn_BG[],CCI2[],upVal[],mdVal[],dnVal[],colors[],trend[];

int init()
{
   color BGColor = BackgroundColor();
   IndicatorBuffers(13);
   SetIndexBuffer(0, CCI_HistoUp);    SetIndexStyle(0 ,DRAW_HISTOGRAM);
   SetIndexBuffer(1, CCI_HistoDn);    SetIndexStyle(1 ,DRAW_HISTOGRAM);
   SetIndexBuffer(2, CCI_HistoUp_BG); SetIndexStyle(2 ,DRAW_HISTOGRAM,0,3,BGColor);
   SetIndexBuffer(3, CCI_HistoDn_BG); SetIndexStyle(3 ,DRAW_HISTOGRAM,0,3,BGColor);
   SetIndexBuffer(4, CCI1);           SetIndexStyle(4 ,DRAW_LINE); SetIndexLabel(4,"CCI");
   SetIndexBuffer(5, vala);           SetIndexStyle(5 ,DRAW_LINE); SetIndexLabel(5,"CCI Up");
   SetIndexBuffer(6, valb);           SetIndexStyle(6 ,DRAW_LINE); SetIndexLabel(6,"CCI Down");
   SetIndexBuffer(7, CCI2);           SetIndexStyle(7 ,DRAW_LINE);
   SetIndexBuffer(8, upVal);          SetIndexStyle(8 ,DRAW_LINE);
   SetIndexBuffer(9, dnVal);          SetIndexStyle(9 ,DRAW_LINE);
   SetIndexBuffer(10,mdVal);          SetIndexStyle(10,DRAW_LINE);
   SetIndexBuffer(11,colors);
   SetIndexBuffer(12,trend);
   
   IndicatorShortName("CCI Highlight");
return(0);
}
void OnDeinit(const int reason)
 { 
 
  ObjectsDeleteAll(0,arrowsId+":"); 
  
  
    }

int start()
  {
   
   int i;
   int counted_bars=IndicatorCounted();
   int limit = Bars-counted_bars-1;
   
   //int cci_color = 0;
   if (colors[limit]==-1) CleanPoint(limit,vala,valb);
   for(i=limit; i>=0; i--)
   {
      CCI1[i] = iCCI(NULL,0,CCI_Period1,PRICE_TYPICAL,i);
      CCI2[i] = iCCI(NULL,0,CCI_Period2,PRICE_TYPICAL,i);
      upVal[i] = CCI_OverBought;
      mdVal[i] = 0;
      dnVal[i] = CCI_OverSold;
      colors[i] = (i<Bars-1) ? (CCI1[i]>0) ? 1 : (CCI1[i]<0) ? -1 : colors[i+1] : 0;
      vala[i]   = valb[i]   = EMPTY_VALUE; if (colors[i]==-1) PlotPoint(i,vala,valb,CCI1);
      CCI_HistoUp[i] = CCI_HistoUp_BG[i] = EMPTY_VALUE;
      CCI_HistoDn[i] = CCI_HistoDn_BG[i] = EMPTY_VALUE;
      if (CCI1[i]>0) 
      {   
         CCI_HistoUp[i]    = CCI1[i];
         CCI_HistoUp_BG[i] = upVal[i];
      }
      if (CCI1[i]<0)
      {
         CCI_HistoDn[i]    = CCI1[i];
         CCI_HistoDn_BG[i] = dnVal[i];
      } 
      trend[i] = (i<Bars-1) ? (CCI1[i]>upVal[i]) ? 1 : (CCI1[i]<dnVal[i]) ? -1 : (CCI1[i]<upVal[i] && CCI1[i]>dnVal[i]) ? 0 : trend[i+1] : 0;  
      
      //
      //
      //
         
      if (arrowsVisible)
      {
        string lookFor = arrowsId+":"+(string)Time[i]; if (ObjectFind(0,lookFor)==0) ObjectDelete(0,lookFor);                       
        if (i<(Bars-1) && trend[i] != trend[i+1])
        {
           if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
           if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnSize, true);
        }
      }
   }
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (colors[whichBar] != colors[whichBar+1])
      {
         if (colors[whichBar] == 1) doAlert(" crossing zero up");
         if (colors[whichBar] ==-1) doAlert(" crossing zero down");       
      }         
   }    
return(0);
}
  
color BackgroundColor(){
   long bgcolor=clrNONE;
   ResetLastError();
   if(!ChartGetInteger(0,CHART_COLOR_BACKGROUND,0,bgcolor)){
      Print(__FUNCTION__+", Error_Code = ",GetLastError());
   }
   return((color)bgcolor);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//
//
//

void drawArrow(int i,color theColor,int theCode, int theSize, bool up)
{
     string aname = arrowsId+":"+(string)Time[i];
     double gap   = iATR(NULL,0,20,i);   
   
      //
      //
      //

      datetime atime = Time[i];// if (arrowsOnFirst) atime += PeriodSeconds(_Period)-1;        
      ObjectCreate(aname,OBJ_ARROW,0,atime,0);
         ObjectSet(aname,OBJPROP_ARROWCODE,theCode);
         ObjectSet(aname,OBJPROP_COLOR,theColor);
         ObjectSet(aname,OBJPROP_WIDTH,theSize);
         if (up)
               ObjectSet(aname,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(aname,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//------------------------------------------------------------------
// Alert function
//------------------------------------------------------------------

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Cci "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" Cci ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//-------------------------------------------------------------------
// 
//-------------------------------------------------------------------

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
int timeFrameValue(int _tf)
{
   int add  = (_tf>=0) ? 0 : fabs(_tf);
   if (add != 0) _tf = _Period;
   int size = ArraySize(iTfTable); 
      int i =0; for (;i<size; i++) if (iTfTable[i]==_tf) break;
                                   if (i==size) return(_Period);
                                                return(iTfTable[(int)fmin(i+add,size-1)]);
}

